type prop = unit
let prop = ()

type arity = unit
let arity = ()

type nat =
    O
  | S of nat

type color =
    R
  | G
  | Bc
  | C
  | M
  | Y
  | K
  | W

type space =
    CR
  | LF
  | TAB
  | SPC

type document =
    B of document
  | EM of document
  | I of document
  | PL of document
  | St of document
  | TT of document
  | U of document
  | Size of nat * document
  | Color of color * document
  | Text of nat
  | Space of space
  | Seq of document * document
  | Nil

let document_rec f11 f10 f9 f8 f7 f6 f5 f4 f3 f2 f1 f0 f =
  let rec f12 = function
    B d0 -> f11 d0 (f12 d0)
  | EM d0 -> f10 d0 (f12 d0)
  | I d0 -> f9 d0 (f12 d0)
  | PL d0 -> f8 d0 (f12 d0)
  | St d0 -> f7 d0 (f12 d0)
  | TT d0 -> f6 d0 (f12 d0)
  | U d0 -> f5 d0 (f12 d0)
  | Size (n, d0) -> f4 n d0 (f12 d0)
  | Color (c, d0) -> f3 c d0 (f12 d0)
  | Text n -> f2 n
  | Space s -> f1 s
  | Seq (d1, d0) -> f0 d1 (f12 d1) d0 (f12 d0)
  | Nil -> f
  in f12

type bool =
    True
  | False

type sumbool =
    Left
  | Right

let bool_dec = function
  True -> (fun b -> match b with
                      True -> Left
                    | False -> Right)
| False -> (fun b -> match b with
                       True -> Right
                     | False -> Left)

type context =
    Mkcontext of bool * bool * bool * bool * bool * nat * nat * color

let b = function
  Mkcontext (b0, em, i, s, tt, u, sizec, colorc) -> b0

let em = function
  Mkcontext (b0, em0, i, s, tt, u, sizec, colorc) -> em0

let i = function
  Mkcontext (b0, em0, i0, s, tt, u, sizec, colorc) -> i0

let s = function
  Mkcontext (b0, em0, i0, s0, tt, u, sizec, colorc) -> s0

let tt = function
  Mkcontext (b0, em0, i0, s0, tt0, u, sizec, colorc) -> tt0

let u = function
  Mkcontext (b0, em0, i0, s0, tt0, u0, sizec, colorc) -> u0

let sizec = function
  Mkcontext (b0, em0, i0, s0, tt0, u0, sizec0, colorc) -> sizec0

let colorc = function
  Mkcontext (b0, em0, i0, s0, tt0, u0, sizec0, colorc0) -> colorc0

let negb = function
  True -> False
| False -> True

let le_lt_dec n =
  let rec f = function
    O -> (fun m -> Left)
  | S n1 -> (fun m ->
      let rec f0 = function
        O -> Right
      | S n3 -> (match f n1 n3 with
                   Left -> Left
                 | Right -> Right)
      in f0 m)
  in f n

type 'A option =
    None
  | Some of 'A

let context_rec f = function
  Mkcontext (b0, em0, i0, s0, tt0, u0, sizec0, colorc0) ->
    f b0 em0 i0 s0 tt0 u0 sizec0 colorc0

let color_rec f6 f5 f4 f3 f2 f1 f0 f = function
  R -> f6
| G -> f5
| Bc -> f4
| C -> f3
| M -> f2
| Y -> f1
| K -> f0
| W -> f

let color_dec a =
  color_rec (fun b0 ->
    match b0 with
      R -> Left
    | G -> Right
    | Bc -> Right
    | C -> Right
    | M -> Right
    | Y -> Right
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Left
    | Bc -> Right
    | C -> Right
    | M -> Right
    | Y -> Right
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Left
    | C -> Right
    | M -> Right
    | Y -> Right
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Right
    | C -> Left
    | M -> Right
    | Y -> Right
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Right
    | C -> Right
    | M -> Left
    | Y -> Right
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Right
    | C -> Right
    | M -> Right
    | Y -> Left
    | K -> Right
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Right
    | C -> Right
    | M -> Right
    | Y -> Right
    | K -> Left
    | W -> Right) (fun b0 ->
    match b0 with
      R -> Right
    | G -> Right
    | Bc -> Right
    | C -> Right
    | M -> Right
    | Y -> Right
    | K -> Right
    | W -> Left) a

let eq_nat_dec n =
  let rec f = function
    O -> (fun m ->
      let rec f0 = function
        O -> Left
      | S n2 -> Right
      in f0 m)
  | S n1 -> (fun m ->
      let rec f0 = function
        O -> Right
      | S n3 -> (match f n1 n3 with
                   Left -> Left
                 | Right -> Right)
      in f0 m)
  in f n

let context_dec a =
  context_rec (fun b1 em0 i0 s0 tt0 u0 sizec0 colorc0 b0 ->
    match b0 with
      Mkcontext (b2, em1, i1, s1, tt1, u1, sizec1, colorc1) ->
        (match bool_dec b1 b2 with
           Left ->
             (match bool_dec em0 em1 with
                Left ->
                  (match bool_dec i0 i1 with
                     Left ->
                       (match bool_dec s0 s1 with
                          Left ->
                            (match bool_dec tt0 tt1 with
                               Left ->
                                 (match eq_nat_dec u0 u1 with
                                    Left ->
                                      (match eq_nat_dec sizec0 sizec1 with
                                         Left ->
                                           (match color_dec colorc0
                                                    colorc1 with
                                              Left -> Left
                                            | Right -> Right)
                                       | Right -> Right)
                                  | Right -> Right)
                             | Right -> Right)
                        | Right -> Right)
                   | Right -> Right)
              | Right -> Right)
         | Right -> Right)) a

type 'A list =
    Nil0
  | Cons of 'A * 'A list

type ('A, 'B) prod =
    Pair of 'A * 'B

type car =
    Print of nat
  | Spc of space

let app x =
  let rec app0 l m =
    match l with
      Nil0 -> m
    | Cons (a, l1) -> Cons (a, (app0 l1 m))
  in app0 x

let rev x =
  let rec rev0 = function
    Nil0 -> Nil0
  | Cons (x0, l') -> app (rev0 l') (Cons (x0, Nil0))
  in rev0 x

let meaning x =
  let rec meaning0 c prev = function
    B d ->
      meaning0 (Mkcontext (True, (em c), (i c), (s c), (tt c), 
        (u c), (sizec c), (colorc c))) prev d
  | EM d ->
      (match s c with
         True -> meaning0 c prev d
       | False ->
           meaning0 (Mkcontext ((b c), (negb (em c)), (i c), (s c),
             (tt c), (u c), (sizec c), (colorc c))) prev d)
  | I d ->
      meaning0 (Mkcontext ((b c), (em c), True, (s c), (tt c), 
        (u c), (sizec c), (colorc c))) prev d
  | PL d ->
      meaning0 (Mkcontext (False, False, False, False, False, O,
        (sizec c), (colorc c))) prev d
  | St d ->
      meaning0 (Mkcontext ((b c), False, (i c), True, (tt c), (u c),
        (sizec c), (colorc c))) prev d
  | TT d ->
      meaning0 (Mkcontext ((b c), (em c), (i c), (s c), True, (u c),
        (sizec c), (colorc c))) prev d
  | U d ->
      (match le_lt_dec (u c) (S (S O)) with
         Left ->
           meaning0 (Mkcontext ((b c), (em c), (i c), (s c), (tt c), (S
             (u c)), (sizec c), (colorc c))) prev d
       | Right -> meaning0 c prev d)
  | Size (n, d) ->
      meaning0 (Mkcontext ((b c), (em c), (i c), (s c), (tt c), 
        (u c), n, (colorc c))) prev d
  | Color (n, d) ->
      meaning0 (Mkcontext ((b c), (em c), (i c), (s c), (tt c), 
        (u c), (sizec c), n)) prev d
  | Text n -> Cons ((Pair ((Print n), c)), Nil0)
  | Space sp ->
      let space_context =
        match eq_nat_dec (u c) O with
          Left -> Mkcontext (False, False, False, False, (tt c), 
            (u c), (sizec c), W)
        | Right -> Mkcontext (False, False, False, False, (tt c),
            (u c), (sizec c), (colorc c)) in
      (match tt c with
         True -> Cons ((Pair ((Spc sp), space_context)), Nil0)
       | False ->
           (match prev with
              None -> Cons ((Pair ((Spc sp), space_context)), Nil0)
            | Some ct ->
                (match context_dec ct space_context with
                   Left -> Nil0
                 | Right -> Cons ((Pair ((Spc sp), space_context)),
                     Nil0))))
  | Seq (d1, d2) ->
      let list_d1 = meaning0 c prev d1 in
      (match rev list_d1 with
         Nil0 -> meaning0 c prev d2
       | Cons (y, t) ->
           (match y with
              Pair (c0, ct) ->
                (match c0 with
                   Print n -> app list_d1 (meaning0 c None d2)
                 | Spc s0 -> app list_d1 (meaning0 c (Some ct) d2))))
  | Nil -> Nil0
  in meaning0 x

type 'A sumor =
    Inleft of 'A
  | Inright

type ('A, 'P) sigS =
    ExistS of 'A * 'P

let sigS_rec f = function
  ExistS (x, p) -> f x p

let prod_rec f = function
  Pair (a, b0) -> f a b0

let list_dec l =
  let rec f = function
    Nil0 -> Inright
  | Cons (a, l1) -> Inleft (ExistS (a, l1))
  in f l

let existP p =
  document_rec (fun d h state co ->
    match bool_dec (b state) True with
      Left -> h state co
    | Right -> B
        (h (Mkcontext (True, (em state), (i state), (s state),
          (tt state), (u state), (sizec state), (colorc state))) co))
    (fun d h state co ->
    match bool_dec (s state) True with
      Left -> h state co
    | Right ->
        document_rec (fun d0 h0 _ -> EM (B d0)) (fun d0 h0 _ -> d0)
          (fun d0 h0 _ -> EM (I d0)) (fun d0 h0 _ -> EM (PL d0))
          (fun d0 h0 _ -> EM (St d0)) (fun d0 h0 _ -> EM (TT d0))
          (fun d0 h0 _ -> EM (U d0)) (fun n0 d0 h0 _ -> EM (Size (n0,
          d0))) (fun c d0 h0 _ -> EM (Color (c, d0))) (fun n0 _ -> EM
          (Text n0)) (fun s0 _ -> EM (Space s0)) (fun d0 h1 d1 h0 _ ->
          EM (Seq (d0, d1))) (fun _ -> EM Nil)
          (h (Mkcontext ((b state), (negb (em state)), (i state),
            (s state), (tt state), (u state), (sizec state),
            (colorc state))) co) prop) (fun d h state co ->
    match bool_dec (i state) True with
      Left -> h state co
    | Right -> I
        (h (Mkcontext ((b state), (em state), True, (s state),
          (tt state), (u state), (sizec state), (colorc state))) co))
    (fun d h state co -> PL
    (h (Mkcontext (False, False, False, False, False, O, (sizec state),
      (colorc state))) co)) (fun d h state co -> St
    (h (Mkcontext ((b state), False, (i state), True, (tt state),
      (u state), (sizec state), (colorc state))) co))
    (fun d h state co ->
    match bool_dec (tt state) True with
      Left -> h state co
    | Right -> TT
        (h (Mkcontext ((b state), (em state), (i state), (s state),
          True, (u state), (sizec state), (colorc state))) co))
    (fun d h state co ->
    match le_lt_dec (u state) (S (S O)) with
      Left -> U
        (h (Mkcontext ((b state), (em state), (i state), (s state),
          (tt state), (S (u state)), (sizec state), (colorc state)))
          co)
    | Right -> h state co) (fun n d h state co -> Size (n,
    (h (Mkcontext ((b state), (em state), (i state), (s state),
      (tt state), (u state), n, (colorc state))) co)))
    (fun c d h state co -> Color (c,
    (h (Mkcontext ((b state), (em state), (i state), (s state),
      (tt state), (u state), (sizec state), c)) co)))
    (fun n state co -> Text n) (fun s0 state co ->
    match bool_dec (tt state) True with
      Left -> Space s0
    | Right ->
        (match co with
           None -> Space s0
         | Some a ->
             (match context_dec a
                      (match eq_nat_dec (u state) O with
                         Left -> Mkcontext (False, False, False, False,
                           False, (u state), (sizec state), W)
                       | Right -> Mkcontext (False, False, False,
                           False, False, (u state), (sizec state),
                           (colorc state))) with
                Left -> Nil
              | Right -> Space s0))) (fun d h d0 h0 state co ->
    let s0 = h state co in
    (match list_dec (rev (meaning state co s0)) with
       Inleft a ->
         sigS_rec (fun x0 p0 ->
           prod_rec (fun a0 ->
             match a0 with
               Print n -> (fun b0 _ -> Seq (s0, (h0 state None)))
             | Spc s1 -> (fun b0 _ -> Seq (s0, (h0 state (Some b0)))))
             x0 prop) a
     | Inright -> h0 state co)) (fun state co -> Nil) p

